/** Main file for USB storage key **/
/** Memory access test            **/
/** 1 blink cannot find memory    **/
/** 5 blinks memory found         **/

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdint.h>

#include "io.h"
#include "spi.h"
#include "AT45DB641E.h"

// Constants

// #define DEBUG

#define MAX_LED		1

#define LED		0

#define PORTB_OUTPUT	0x40
#define PORTC_OUTPUT	0x00
#define PORTD_OUTPUT	0x0C
#define PORTE_OUTPUT	0x00
#define PORTF_OUTPUT	0x60

#define LED_NB_START	10

unsigned char led1[]={0x00,0x00,0x0C,0x00,0x60};

unsigned char *leds[]={led1};

#define MEM1_DDR	DDRB
#define MEM1_PORT	PORTB
#define MEM1_PIN	0

uint8_t manufacturer[]={0x1f,0x28,0x00,0x01,0x00};

void blink_ending(int led){
  int i, nb;
  nb = 3;
  // output_unset(leds,led); _delay_ms(2000);
  output_set(leds,led); _delay_ms(2000);
  for(i=0;i<nb;i++){
    output_unset(leds,led); _delay_ms(50);
    output_set(leds,led); _delay_ms(50);
  }
  // output_unset(leds,led); _delay_ms(2000);
  output_set(leds,led); _delay_ms(2000);
}

#ifdef DEBUG
void blink_byte(uint8_t byte,int led){
int i;
for(i=0;i<8;i++){
  int nb=(byte&0x01)?2:1;
  int j;
  for(j=0;j<nb;j++){
    output_set(leds,led); _delay_ms(100);
    output_unset(leds,led); _delay_ms(100);
    }
  _delay_ms(1000);
  byte >>= 1;
  }
  blink_ending(led);
}
#endif

void blink_start(int led){
int i;
for(i=0;i<LED_NB_START;i++){
  output_unset(leds,led); _delay_ms(100);
  output_set(leds,led); _delay_ms(100);
  }
blink_ending(led);
}

void blink_bool(uint8_t b,int led){
int i,nb;
if(b) nb=5; else nb=1;
for(i=0;i<nb;i++){
  output_unset(leds,led); _delay_ms(1000);
  output_set(leds,led); _delay_ms(1000);
  }
  blink_ending(led);
}

int main(void)
{
CLKPR = (1<<CLKPCE);
CLKPR = 0;
MCUCR |= (1<<JTD);
MCUCR |= (1<<JTD);

unsigned char omasks[]={PORTB_OUTPUT,PORTC_OUTPUT,PORTD_OUTPUT,PORTE_OUTPUT,PORTF_OUTPUT};
outputs_init(omasks);

// int i;
// for(i=0;i<10;i++){
//   output_set(leds,LED); _delay_ms(100);
//   output_unset(leds,LED); _delay_ms(100);
//   }
// _delay_ms(1000);

MEM1_DDR |= (1<<MEM1_PIN);
MEM1_PORT |= (1<<MEM1_PIN);
spi_init();

// for(i=0;i<MEM_SIZE/PAGE_SIZE;i++){
//
// }


uint8_t result[5];
uint8_t ok;
int i;
blink_start(LED);
_delay_ms(1000);
AT45DB641E_cmd(&MEM1_PORT,MEM1_PIN,AT45DB641E_Manufacturer,result,5);
// AT45DB641E_cmd(&MEM1_PORT,MEM1_PIN,0xAA,result,5);
#ifdef DEBUG
for(i=0;i<5;i++) blink_byte(result[i],LED);
#endif
ok=1; for(i=0;i<5;i++) if(result[i]!=manufacturer[i]){ ok=0; break; }
blink_bool(ok,LED);

return 0;
}
